## org.hibernate.cache.impl.bridge
Class CollectionAccessStrategyAdapter

    java.lang.Object
      org.hibernate.cache.impl.bridge.CollectionAccessStrategyAdapter

All Implemented Interfaces:
  CollectionRegionAccessStrategy

    public class CollectionAccessStrategyAdapter

extends Object
implements CollectionRegionAccessStrategy

Adapter specifically bridging `CollectionRegionAccessStrategy` to `CacheConcurrencyStrategy`.

Author:
  Steve Ebersole

Constructor Summary
`CollectionAccessStrategyAdapter(CollectionRegion region, CacheConcurrencyStrategy ccs, Settings settings)`

Method Summary
`void` `destroy()`
`void` `evict(Object key)` Forcibly evict an item from the cache immediately without regard for transaction isolation.
`void` `evictAll()` Forcibly evict all items from the cache immediately without regard for transaction isolation.
`Object` `get(Object key, long txTimestamp)` Attempt to retrieve an object from the cache.
`CollectionRegion` `getRegion()` Get the wrapped collection cache region
`SoftLock` `lockItem(Object key, Object version)` We are going to attempt to update/delete the keyed object.
`SoftLock` `lockRegion()` Lock the entire region
`boolean` `putFromLoad(Object key, Object value, long txTimestamp, Object version)` Attempt to cache an object, after loading from the database.
`boolean` `putFromLoad(Object key, Object value, long txTimestamp, Object version, boolean minimalPutOverride)` Attempt to cache an object, after loading from the database, explicitly specifying the minimalPut behavior.
`void` `remove(Object key)` Called after an item has become stale (before the transaction completes).
`void` `removeAll()` Called to evict data from the entire region
`void` `unlockItem(Object key, SoftLock lock)` Called when we have finished the attempted update/delete (which may or may not have been successful), after transaction completion.
`void` `unlockRegion(SoftLock lock)` Called after we have finished the attempted invalidation of the entire region

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CollectionAccessStrategyAdapter

    public CollectionAccessStrategyAdapter(CollectionRegion region,
                                           CacheConcurrencyStrategy ccs,
                                           Settings settings)

Method Detail

### getRegion

    public CollectionRegion getRegion()

  Description copied from interface: `CollectionRegionAccessStrategy`
  Get the wrapped collection cache region

  Specified by:
    `getRegion` in interface `CollectionRegionAccessStrategy`
  Returns:
    The underlying region

### get

    public Object get(Object key,
                      long txTimestamp)
               throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Attempt to retrieve an object from the cache. Mainly used in attempting to resolve entities/collections from the second level cache.

  Specified by:
    `get` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The key of the item to be retrieved.
    `txTimestamp` - a timestamp prior to the transaction start time
  Returns:
    the cached object or `null`
  Throws:
    `CacheException` - Propogated from underlying `Region`

### putFromLoad

    public boolean putFromLoad(Object key,
                               Object value,
                               long txTimestamp,
                               Object version)
                        throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Attempt to cache an object, after loading from the database.

  Specified by:
    `putFromLoad` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The item key
    `value` - The item
    `txTimestamp` - a timestamp prior to the transaction start time
    `version` - the item version number
  Returns:
    `true` if the object was successfully cached
  Throws:
    `CacheException` - Propogated from underlying `Region`

### putFromLoad

    public boolean putFromLoad(Object key,
                               Object value,
                               long txTimestamp,
                               Object version,
                               boolean minimalPutOverride)
                        throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Attempt to cache an object, after loading from the database, explicitly specifying the minimalPut behavior.

  Specified by:
    `putFromLoad` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The item key
    `value` - The item
    `txTimestamp` - a timestamp prior to the transaction start time
    `version` - the item version number
    `minimalPutOverride` - Explicit minimalPut flag
  Returns:
    `true` if the object was successfully cached
  Throws:
    `CacheException` - Propogated from underlying `Region`

### lockItem

    public SoftLock lockItem(Object key,
                             Object version)
                      throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  We are going to attempt to update/delete the keyed object. This method is used by "asynchronous" concurrency strategies.

  The returned object must be passed back to release(), to release the lock. Concurrency strategies which do not support client-visible locks may silently return null.

  Specified by:
    `lockItem` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The key of the item to lock
    `version` - The item's current version value
  Returns:
    A representation of our lock on the item; or null.
  Throws:
    `CacheException` - Propogated from underlying `Region`

### lockRegion

    public SoftLock lockRegion()
                        throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Lock the entire region

  Specified by:
    `lockRegion` in interface `CollectionRegionAccessStrategy`
  Returns:
    A representation of our lock on the item; or null.
  Throws:
    `CacheException` - Propogated from underlying `Region`

### unlockItem

    public void unlockItem(Object key,
                           SoftLock lock)
                    throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Called when we have finished the attempted update/delete (which may or may not have been successful), after transaction completion. This method is used by "asynchronous" concurrency strategies.

  Specified by:
    `unlockItem` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The item key
    `lock` - The lock previously obtained from `CollectionRegionAccessStrategy.lockItem(java.lang.Object, java.lang.Object)`
  Throws:
    `CacheException` - Propogated from underlying `Region`

### unlockRegion

    public void unlockRegion(SoftLock lock)
                      throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Called after we have finished the attempted invalidation of the entire region

  Specified by:
    `unlockRegion` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `lock` - The lock previously obtained from `CollectionRegionAccessStrategy.lockRegion()`
  Throws:
    `CacheException` - Propogated from underlying `Region`

### remove

    public void remove(Object key)
                throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Called after an item has become stale (before the transaction completes). This method is used by "synchronous" concurrency strategies.

  Specified by:
    `remove` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The key of the item to remove
  Throws:
    `CacheException` - Propogated from underlying `Region`

### removeAll

    public void removeAll()
                   throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Called to evict data from the entire region

  Specified by:
    `removeAll` in interface `CollectionRegionAccessStrategy`
  Throws:
    `CacheException` - Propogated from underlying `Region`

### evict

    public void evict(Object key)
               throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Forcibly evict an item from the cache immediately without regard for transaction isolation.

  Specified by:
    `evict` in interface `CollectionRegionAccessStrategy`
  Parameters:
    `key` - The key of the item to remove
  Throws:
    `CacheException` - Propogated from underlying `Region`

### evictAll

    public void evictAll()
                  throws CacheException

  Description copied from interface: `CollectionRegionAccessStrategy`
  Forcibly evict all items from the cache immediately without regard for transaction isolation.

  Specified by:
    `evictAll` in interface `CollectionRegionAccessStrategy`
  Throws:
    `CacheException` - Propogated from underlying `Region`

### destroy

    public void destroy()

Copyright © 2001-2010 Red Hat, Inc. All Rights Reserved.